]> git.ipfire.org Git - thirdparty/kernel/stable.git/blame - scripts/link-vmlinux.sh
Merge branch 'for-5.1-fixes' of git://git.kernel.org/pub/scm/linux/kernel/git/tj...
[thirdparty/kernel/stable.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
d151e971
MY
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
1f2bfbd0
SR
11#
12# vmlinux
13# ^
14# |
d151e971
MY
15# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
1f2bfbd0 17# |
3a166fc2
NP
18# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
1f2bfbd0
SR
21# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
38 printf " %-7s %s\n" ${1} ${2}
39 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
a5967db9
SR
46 local objects
47
6358d6e8 48 objects="--whole-archive \
d151e971 49 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
50 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
d503ac53 55 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
56}
57
58# Link of vmlinux
59# ${1} - optional extra .o files
60# ${2} - output file
61vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
a5967db9 64 local objects
1f2bfbd0
SR
65
66 if [ "${SRCARCH}" != "um" ]; then
6358d6e8 67 objects="--whole-archive \
d151e971 68 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
69 --no-whole-archive \
70 --start-group \
71 ${KBUILD_VMLINUX_LIBS} \
72 --end-group \
73 ${1}"
a5967db9 74
d503ac53 75 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
a5967db9 76 -T ${lds} ${objects}
1f2bfbd0 77 else
6358d6e8 78 objects="-Wl,--whole-archive \
d151e971 79 ${KBUILD_VMLINUX_OBJS} \
6358d6e8
NP
80 -Wl,--no-whole-archive \
81 -Wl,--start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 -Wl,--end-group \
84 ${1}"
a5967db9 85
6358d6e8
NP
86 ${CC} ${CFLAGS_vmlinux} -o ${2} \
87 -Wl,-T,${lds} \
88 ${objects} \
a5967db9 89 -lutil -lrt -lpthread
1f2bfbd0
SR
90 rm -f linux
91 fi
92}
93
94
95# Create ${2} .o file with all symbols from the ${1} object file
96kallsyms()
97{
98 info KSYM ${2}
99 local kallsymopt;
100
101 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 102 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
103 fi
104
4d5d5664 105 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
106 kallsymopt="${kallsymopt} --absolute-percpu"
107 fi
108
2213e9a6
AB
109 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
110 kallsymopt="${kallsymopt} --base-relative"
111 fi
112
00e6c28c
SR
113 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
114 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 115
a0439342
AB
116 local afile="`basename ${2} .o`.S"
117
118 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
119 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
120}
121
122# Create map file with all symbols from ${1}
123# See mksymap for additional details
124mksysmap()
125{
126 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
127}
128
1347a2ce
LT
129sortextable()
130{
131 ${objtree}/scripts/sortextable ${1}
132}
133
1f2bfbd0 134# Delete output files in case of error
1f2bfbd0
SR
135cleanup()
136{
1f2bfbd0
SR
137 rm -f .tmp_System.map
138 rm -f .tmp_kallsyms*
1f2bfbd0
SR
139 rm -f .tmp_vmlinux*
140 rm -f System.map
141 rm -f vmlinux
142 rm -f vmlinux.o
143}
144
ab160dbb
SB
145on_exit()
146{
147 if [ $? -ne 0 ]; then
148 cleanup
149 fi
150}
151trap on_exit EXIT
152
153on_signals()
154{
155 exit 1
156}
157trap on_signals HUP INT QUIT TERM
158
1f2bfbd0
SR
159#
160#
161# Use "make V=1" to debug this script
162case "${KBUILD_VERBOSE}" in
163*1*)
164 set -x
165 ;;
166esac
167
168if [ "$1" = "clean" ]; then
169 cleanup
170 exit 0
171fi
172
173# We need access to CONFIG_ symbols
94cf8acc 174. include/config/auto.conf
1f2bfbd0 175
1f2bfbd0
SR
176# Update version
177info GEN .version
278ae604
MY
178if [ -r .version ]; then
179 VERSION=$(expr 0$(cat .version) + 1)
180 echo $VERSION > .version
1f2bfbd0 181else
278ae604
MY
182 rm -f .version
183 echo 1 > .version
1f2bfbd0
SR
184fi;
185
186# final build of init/
a7b151ff 187${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
1f2bfbd0 188
abac4c89
NP
189#link vmlinux.o
190info LD vmlinux.o
191modpost_link vmlinux.o
192
193# modpost vmlinux.o to check for section mismatches
194${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
195
1f2bfbd0
SR
196kallsymso=""
197kallsyms_vmlinux=""
198if [ -n "${CONFIG_KALLSYMS}" ]; then
199
200 # kallsyms support
201 # Generate section listing all symbols and add it into vmlinux
202 # It's a three step process:
203 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
204 # but __kallsyms is empty.
205 # Running kallsyms on that gives us .tmp_kallsyms1.o with
206 # the right size
207 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
208 # the right size, but due to the added section, some
209 # addresses have shifted.
210 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
211 # 3) That link may have expanded the kernel image enough that
212 # more linker branch stubs / trampolines had to be added, which
213 # introduces new names, which further expands kallsyms. Do another
214 # pass if that is the case. In theory it's possible this results
215 # in even more stubs, but unlikely.
216 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
217 # other bugs.
218 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
219 #
220 # a) Verify that the System.map from vmlinux matches the map from
221 # ${kallsymso}.
222
223 kallsymso=.tmp_kallsyms2.o
224 kallsyms_vmlinux=.tmp_vmlinux2
225
226 # step 1
227 vmlinux_link "" .tmp_vmlinux1
228 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
229
230 # step 2
231 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
232 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
233
7e2b37c9 234 # step 3
a670b0b4
MF
235 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
236 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
7e2b37c9
NP
237
238 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
1f2bfbd0
SR
239 kallsymso=.tmp_kallsyms3.o
240 kallsyms_vmlinux=.tmp_vmlinux3
241
242 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
243
244 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
245 fi
246fi
247
248info LD vmlinux
249vmlinux_link "${kallsymso}" vmlinux
250
1347a2ce
LT
251if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
252 info SORTEX vmlinux
253 sortextable vmlinux
254fi
255
1f2bfbd0
SR
256info SYSMAP System.map
257mksysmap vmlinux System.map
258
259# step a (see comment above)
260if [ -n "${CONFIG_KALLSYMS}" ]; then
261 mksysmap ${kallsyms_vmlinux} .tmp_System.map
262
263 if ! cmp -s System.map .tmp_System.map; then
5369f550 264 echo >&2 Inconsistent kallsyms data
367e43c5 265 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
266 exit 1
267 fi
268fi